## coin3 4.0.6%2Bds

=== testsuite/CMakeLists.txt ===
macro(create_testsuite input)
	get_filename_component(FLNAME "${input}" NAME_WE)
	get_filename_component(FLPATH "${input}" PATH)
	string(REGEX REPLACE ".*[/\\]" "" FLSUBFLD "${FLPATH}")
	set(COIN_STR_TEST_CLASS "${FLNAME}")
	file(READ ${PROJECT_SOURCE_DIR}/${input} f0)
	if(f0 MATCHES "#ifdef[ \t]+COIN_TEST_SUITE")
		# message(STATUS "Parse: ${PROJECT_SOURCE_DIR}/${input} - ${FLPATHSUB}${FLNAME}Test.cpp")
		# get first include from file, which we assume is include to tested class
		string(REGEX MATCH "[\n\r]+#include[ \t]<[^\n]+" iclass "${f0}")
		# get block between '#ifdef COIN_TEST_SUITE' and '#endif'
		string(REGEX REPLACE ".*#ifdef[ \t]+COIN_TEST_SUITE" "" f1 "${f0}")
		string(REGEX REPLACE "#endif[ \t/!]+COIN_TEST_SUITE.*" "" f2 "${f1}")
		# get all #include statements within COIN_TEST_SUITE code block
		string(REGEX MATCHALL "#include[ \t]<[^\n]+" i0 "${f2}")
		string(REPLACE ";" "\n" COIN_STR_TEST_INCL "${i0}")
		set(COIN_STR_TEST_INCL "${iclass}\n${COIN_STR_TEST_INCL}")
		# remove #include statements from test code string (moved to ${COIN_STR_TEST_INCL})
		string(REGEX REPLACE "[\n\r ]*#include[ \t]<[^\n]+" "" COIN_STR_TEST_CODE "${f2}")
		# generate new test code file with extracted snippets
		configure_file(TestSuiteTemplate.cmake.in "${FLSUBFLD}${FLNAME}Test.cpp")
	endif()
endmacro()

macro(create_file_test input testfunc filter)
	file(GLOB_RECURSE COIN_IV_FILES RELATIVE ${PROJECT_SOURCE_DIR} ../${input}/*.wrl ../${input}/*.vrml ../${input}/*.gz ../${input}/*.iv)
	string(REGEX REPLACE "[\\./\\-]+" "" TESTSUITENAME "${input}")
	set(COIN_STR_TEST_INCL "")
	set(COIN_STR_TEST_CODE "const char *readError[] = { \"Coin read error:\", 0 };\n")
	set(COIN_STR_TEST_CLASS "${TESTSUITENAME}")
	set(extra_macro_args ${ARGN})
	list(LENGTH extra_macro_args num_extra_args)
	foreach(INPUTFILE ${COIN_IV_FILES})
		if(${num_extra_args} EQUAL 0 OR NOT ("${INPUTFILE}" MATCHES "${extra_macro_args}"))
			string(REGEX REPLACE "[\\./\\-]+" "_" TESTNAME "${INPUTFILE}")
			if (${filter})
				set(COIN_STR_TEST_CODE "${COIN_STR_TEST_CODE}\nBOOST_AUTO_TEST_CASE(${TESTNAME}) { PushMessageSuppressFilters(readError); ResetReadErrorCount(); test_file(\"${PROJECT_SOURCE_DIR}/${INPUTFILE}\", &${testfunc}); PopMessageSuppressFilters(); }")
			else()
				set(COIN_STR_TEST_CODE "${COIN_STR_TEST_CODE}\nBOOST_AUTO_TEST_CASE(${TESTNAME}) { ResetReadErrorCount(); test_file(\"${PROJECT_SOURCE_DIR}/${INPUTFILE}\", &${testfunc}); }")
			endif()
		endif()
	endforeach()
	configure_file(TestSuiteTemplate.cmake.in "${TESTSUITENAME}Test.cpp")
endmacro()

# Parse all source files for embedded '#ifdef COIN_TEST_SUITE' and extract those blocks
# to separate test source files.
file(GLOB_RECURSE COIN_SRC_FILES RELATIVE ${PROJECT_SOURCE_DIR} ${PROJECT_SOURCE_DIR}/src/*.cpp)
foreach(INPUTFILE ${COIN_SRC_FILES})
	create_testsuite(${INPUTFILE})
endforeach()

# Create test cases for all scenes under models folder (this replaces StandardTests.cpp).
# The original StandardTests.cpp also tested additional folders:
# - "killers" with testInCorrectFile
# - "slackers" with testOutOfSpecFile
# However, those folders are not in the repository.
create_file_test("models" "testCorrectFile" false "incorrect")
# bug039.iv and bug055-5.iv contain errors but load anyway: ignore for now
create_file_test("models/io/incorrect" "testIncorrectFile" true "(bug039|bug055-5)")

# Include all extracted '*Tests.cpp' files in the target.
FILE(GLOB COIN_TEST_SOURCES "${CMAKE_CURRENT_BINARY_DIR}/*Test.cpp")

add_executable(CoinTests TestSuiteMain.cpp TestSuiteUtils.cpp TestSuiteMisc.cpp ${COIN_TEST_SOURCES})
set_target_properties(CoinTests PROPERTIES DEBUG_POSTFIX "${CMAKE_DEBUG_POSTFIX}")
target_link_libraries(CoinTests Coin ${COIN_TARGET_LINK_LIBRARIES})
target_include_directories(CoinTests PRIVATE
	${CMAKE_CURRENT_SOURCE_DIR}
	${PROJECT_SOURCE_DIR}/include
	${PROJECT_SOURCE_DIR}/include/Inventor/annex
	${PROJECT_BINARY_DIR}/include
	${COIN_TARGET_INCLUDE_DIRECTORIES}
)
if (USE_PTHREAD)
	target_link_libraries(CoinTests pthread)
endif()
add_test(NAME CoinTests COMMAND CoinTests)

# Many warnings are generated from test macros on macOS with Xcode.
include(CheckCXXCompilerFlag)
CHECK_CXX_COMPILER_FLAG(-Wtautological-compare DISABLE_WARNING_TAUTOLOGCOMPARE)
if(DISABLE_WARNING_TAUTOLOGCOMPARE)
	target_compile_options(CoinTests PUBLIC -Wno-tautological-compare)
endif()

=== examples/sdl3/CMakeLists.txt ===
if (CMAKE_BUILD_TYPE STREQUAL "Debug")
  add_definitions(-DCOIN_DEBUG=1)
else()
  add_definitions(-DCOIN_DEBUG=0)
endif()

find_package(SDL3 REQUIRED)

add_executable(sdl3-example sdl3.cpp)

target_include_directories(sdl3-example PRIVATE
	${CMAKE_CURRENT_SOURCE_DIR}
	${PROJECT_SOURCE_DIR}/include
	${PROJECT_SOURCE_DIR}/include/Inventor/annex
	${PROJECT_BINARY_DIR}/include
	${COIN_TARGET_INCLUDE_DIRECTORIES}
)

target_link_libraries(sdl3-example SDL3 Coin GL)
target_link_libraries(sdl3-example ${COIN_TARGET_LINK_LIBRARIES_GL})

=== src/collision/CMakeLists.txt ===
# source files
set(COIN_COLLISION_FILES
	SbTri3f.cpp
	SoIntersectionDetectionAction.cpp
)

# Files excluded from public API documentation, included in complete documentation.
set(COIN_COLLISION_INTERNAL_FILES
	SbTri3f.h
	SbTri3f.cpp
)

# build library
if(COIN_BUILD_SINGLE_LIB)
	foreach(SRCFILE ${COIN_COLLISION_FILES})
		set(COIN_SOURCE ${COIN_SOURCE} collision/${SRCFILE} CACHE INTERNAL "COIN_SOURCE")
	endforeach(SRCFILE)
else()
	add_library(collision OBJECT ${COIN_COLLISION_FILES})
endif()

# define documentation
foreach(SRCFILE ${COIN_COLLISION_FILES})
	set(COIN_DOCUMENTATION_FILES ${COIN_DOCUMENTATION_FILES} ${PROJECT_SOURCE_DIR}/src/collision/${SRCFILE} CACHE INTERNAL "COIN_DOCUMENTATION_FILES")
endforeach(SRCFILE)
foreach(SRCFILE ${COIN_COLLISION_INTERNAL_FILES})
	set(COIN_INTERNAL_DOCUMENTATION_FILES ${COIN_INTERNAL_DOCUMENTATION_FILES} ${PROJECT_SOURCE_DIR}/src/collision/${SRCFILE} CACHE INTERNAL "COIN_INTERNAL_DOCUMENTATION_FILES")
endforeach(SRCFILE)

=== src/elements/CMakeLists.txt ===
add_subdirectory(GL)

# source files
set(COIN_ELEMENTS_FILES
	SoAccumulatedElement.cpp
	SoAmbientColorElement.cpp
	SoAnnoText3CharOrientElement.cpp
	SoAnnoText3FontSizeHintElement.cpp
	SoAnnoText3RenderPrintElement.cpp
	SoBBoxModelMatrixElement.cpp
	SoBumpMapElement.cpp
	SoBumpMapCoordinateElement.cpp
	SoBumpMapMatrixElement.cpp
	SoBumpMappingPropertyElement.cpp
	SoCacheElement.cpp
	SoCacheHintElement.cpp
	SoClipPlaneElement.cpp
	SoComplexityElement.cpp
	SoComplexityTypeElement.cpp
	SoCoordinateElement.cpp
	SoCreaseAngleElement.cpp
	SoCullElement.cpp
	SoDecimationPercentageElement.cpp
	SoDecimationTypeElement.cpp
	SoDepthBufferElement.cpp
	SoDiffuseColorElement.cpp
	SoDrawStyleElement.cpp
	SoElement.cpp
	SoEmissiveColorElement.cpp
	SoEnvironmentElement.cpp
	SoFloatElement.cpp
	SoFocalDistanceElement.cpp
	SoFontNameElement.cpp
	SoFontSizeElement.cpp
	SoInt32Element.cpp
	SoLazyElement.cpp
	SoLightAttenuationElement.cpp
	SoLightElement.cpp
	SoLightModelElement.cpp
	SoLinePatternElement.cpp
	SoLineWidthElement.cpp
	SoLocalBBoxMatrixElement.cpp
	SoMaterialBindingElement.cpp
	SoVertexAttributeBindingElement.cpp
	SoMultiTextureCoordinateElement.cpp
	SoMultiTextureEnabledElement.cpp
	SoMultiTextureMatrixElement.cpp
	SoMultiTextureImageElement.cpp
	SoModelMatrixElement.cpp
	SoNormalBindingElement.cpp
	SoNormalElement.cpp
	SoOverrideElement.cpp
	SoPickRayElement.cpp
	SoPickStyleElement.cpp
	SoPointSizeElement.cpp
	SoPolygonOffsetElement.cpp
	SoProfileCoordinateElement.cpp
	SoProfileElement.cpp
	SoProjectionMatrixElement.cpp
	SoReplacedElement.cpp
	SoShapeHintsElement.cpp
	SoShapeStyleElement.cpp
	SoShininessElement.cpp
	SoSpecularColorElement.cpp
	SoSwitchElement.cpp
	SoTextOutlineEnabledElement.cpp
	SoTextureCombineElement.cpp
	SoTextureCoordinateBindingElement.cpp
	SoTextureOverrideElement.cpp
	SoTextureScalePolicyElement.cpp
	SoTextureScaleQualityElement.cpp
	SoTextureUnitElement.cpp
	SoTextureQualityElement.cpp
	SoTransparencyElement.cpp
	SoUnitsElement.cpp
	SoViewVolumeElement.cpp
	SoViewingMatrixElement.cpp
	SoViewportRegionElement.cpp
	SoWindowElement.cpp
	SoListenerPositionElement.cpp
	SoListenerOrientationElement.cpp
	SoListenerGainElement.cpp
	SoListenerDopplerElement.cpp
	SoSoundElement.cpp
	SoVertexAttributeElement.cpp
)

# Files excluded from public API documentation, included in complete documentation.
set(COIN_ELEMENTS_INTERNAL_FILES
	SoTextureScalePolicyElement.h
	SoTextureScalePolicyElement.cpp
	SoTextureScaleQualityElement.h
	SoTextureScaleQualityElement.cpp
	SoVertexAttributeData.h
)

# build library
if(COIN_BUILD_SINGLE_LIB)
	foreach(SRCFILE ${COIN_ELEMENTS_FILES})
		set(COIN_SOURCE ${COIN_SOURCE} elements/${SRCFILE} CACHE INTERNAL "COIN_SOURCE")
	endforeach(SRCFILE)
else()
	add_library(elements OBJECT ${COIN_ELEMENTS_FILES})
endif()

# define documentation
foreach(SRCFILE ${COIN_ELEMENTS_FILES})
	set(COIN_DOCUMENTATION_FILES ${COIN_DOCUMENTATION_FILES} ${PROJECT_SOURCE_DIR}/src/elements/${SRCFILE} CACHE INTERNAL "COIN_DOCUMENTATION_FILES")
endforeach(SRCFILE)
foreach(SRCFILE ${COIN_ELEMENTS_INTERNAL_FILES})
	set(COIN_INTERNAL_DOCUMENTATION_FILES ${COIN_INTERNAL_DOCUMENTATION_FILES} ${PROJECT_SOURCE_DIR}/src/elements/${SRCFILE} CACHE INTERNAL "COIN_INTERNAL_DOCUMENTATION_FILES")
endforeach(SRCFILE)

=== debian/control ===
Source: coin3
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Leopold Palomo-Avellaneda <leo@alaxarxa.net>
Section: graphics
Priority: optional
Build-Depends: dpkg-dev (>= 1.22.5), debhelper-compat (= 13),
               cmake,
               doxygen,
               libexpat-dev,
               libx11-dev,
               libxext-dev,
               libxi-dev,
               libxmu-dev,
               libxpm-dev,
               libxt-dev,
               libboost-all-dev,
               freeglut3-dev,
	       libgl-dev,
	       libglvnd-dev,
	       libopengl-dev,
 	       libglew-dev
Standards-Version: 4.7.2
Rules-Requires-Root: no
Vcs-Browser: https://salsa.debian.org/science-team/coin3
Vcs-Git: https://salsa.debian.org/science-team/coin3.git
Homepage: https://github.com/coin3d

Package: libcoin80t64
Provides: ${t64:Provides}
X-Time64-Compat: libcoin80c
Breaks: libcoin80c (<< ${source:Version})
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${misc:Depends},
         ${shlibs:Depends}
Suggests: libbz2-1.0,
          libfreetype6,
          libopenal0a,
          libsimage-dev,
          zlib1g
Pre-Depends: ${misc:Pre-Depends}
Replaces: libcoin80c, libcoin80v5
Description: high-level 3D graphics kit implementing the Open Inventor API
 Coin is an OpenGL-based, retain-mode 3D graphics library that
 implements the Open Inventor 2.1 API. It also includes support for
 VRML97 and 3D audio.  Installing the suggested packages will enable
 extra features:
 .
     libsimage-dev enables loading of image files in SbImage
     libfreetype6 enables use of TrueType fonts
     libopenal0a   enables audio support
     zlib1g and libbz2 enable transparent read of compressed files

Package: libcoin-dev
Architecture: any
Section: libdevel
Depends: libcoin80t64 (= ${binary:Version}),
         libgl-dev,
	 libopengl-dev,
	 libglew-dev,
         libx11-dev,
         libxext-dev,
         libxi-dev,
         libxmu-dev,
         libxpm-dev,
         libxt-dev,
         ${misc:Depends}
Suggests: libcoin-doc (= ${binary:Version})
Replaces: libcoin80-dev
Breaks: libcoin80-dev
Conflicts: inventor-dev
Description: high-level 3D graphics devkit with Open Inventor and VRML97 support
 Coin is an OpenGL-based, retain-mode 3D graphics library that
 implements the Open Inventor 2.1 API. It also includes support for
 VRML97 and 3D audio.

Package: libcoin-doc
Architecture: all
Multi-Arch: foreign
Section: doc
Depends: ${misc:Depends}
Suggests: libcoin-dev (= ${binary:Version})
Replaces: libcoin80-doc
Breaks: libcoin80-doc
Description: high-level 3D graphics kit with Open Inventor and VRML97 support
 API documentation for the Coin library (the Open Inventor API) in
 HTML format.
 .
 Coin is an OpenGL-based, retain-mode 3D graphics library that
 implements the Open Inventor 2.1 API. It also includes support for
 VRML97 and 3D audio.

Package: libcoin-runtime
Architecture: all
Multi-Arch: foreign
Section: libs
Depends: ${misc:Depends}
Suggests: libcoin80t64
Replaces: libcoin80-runtime
Breaks: libcoin80-runtime
Description: high-level 3D graphics kit - external data files
 External data files used by the Coin library at run-time.  The
 dragger geometry files represent the defaults that are used if the
 files are not found.  This package is completely optional.

=== debian/tests/control ===
Tests: build1, build2, build3
Depends: libcoin-dev, freeglut3-dev, build-essential, xvfb, xauth, cmake
Restrictions: allow-stderr
